import gurobi.*;
import java.util.stream.*;

public class SAT {
    public static void main(String[] args) throws Exception {
        int clauses[][] = {{-1, -1, 0, 0}, {-1, 1, -1, 0}, {-1, 0, 1, -1}, {1, 0 ,0, 1}};
        int nClauses = 4;
	int nLiterals = 4; 

        // Create new environment.
        GRBEnv env = new GRBEnv();

        // Create empty optimization model.
        GRBModel model = new GRBModel(env);

        // Create variables x.
        // addVar(lowerBound, upperBound, objectiveCoeff, variableType, name)
        GRBVar[] x = new GRBVar[nLiterals];
        for (int i = 0; i < nLiterals; i++){
            x[i] =  model.addVar(0.0, 1.0, 0.0, GRB.INTEGER, "literal" + i);
        }

        // Integrate new variables into model.
        model.update();

        // Add constraints:
        // addConstr(leftHandSide, inequalityType, rightHandSide, name)	
	for (int i = 0; i < nClauses; i++) {
	    int sum = 0;
	    GRBLinExpr cons = new GRBLinExpr();
	    for (int j = 0; j < nLiterals; j++) {
		if(clauses[i][j] == 1) {
		    cons.addTerm(1.0, x[j]);
		}

		if(clauses[i][j] == -1) {
		    cons.addTerm(-1.0, x[j]);
		    sum += 1;
		}
	    }

	    model.addConstr(cons, GRB.GREATER_EQUAL, 1 - sum, "cons" + i);
        }
	
	//GRBLinExpr obj = new GRBLinExpr();
	//double[] coeffs = new double [nVertexes];
        //for (int i = 0; i < nVertexes; i++) {
        //    coeffs[i] = 1.0;
        //}

        //obj.addTerms(coeffs, x);
        //model.setObjective(obj, GRB.MAXIMIZE);

        // Solve the model.
        model.optimize();

        // Print the objective
        // and the values of the decision variables in the solution.
        for (int i = 0; i < nLiterals; i++){
            System.out.println(x[i].get(GRB.StringAttr.VarName)+ " " + x[i].get(GRB.DoubleAttr.X));
        }
    }
}
